@ECHO off

:: This install script copies card programs from the windows
:: system folder into the current folder. If finally, starts
:: the Solitaire application.

SETLOCAL ENABLEEXTENSIONS

ECHO.
SET ME=%~n0

ECHO %ME% : Running...

:: Determine the folder that contains this script and change
:: into that folder first! Get path using cmdline 
:: The following works around a bug in SET MY_DIR=%~dps0

FOR %%X IN (%0) DO SET MY_DIR=%%~dpsX
FOR %%X IN (%MY_DIR%) DO SET MY_DIR=%%~dpsX

PUSHD %MY_DIR%

IF NOT EXIST Cards.dll (
  ECHO %ME% : Cards.dll not found!!! Exiting...
  GOTO END
)

IF NOT EXIST Freecell.exe (
  ECHO %ME% : ...Going to copy Freecell from Windows System folder...
  IF EXIST %SYSTEMROOT%\system32\freecell.exe (
    COPY %SYSTEMROOT%\system32\freecell.exe  Freecell.exe >NUL
    IF ERRORLEVEL 1 (
      ECHO %ME% : Freecell copying failed.
    ) ELSE (
      ECHO %ME% : Freecell successfully copied.
    )
  ) ELSE (
    ECHO %ME% : Freecell not found.
  )
) ELSE (
  ECHO %ME% : Freecell already exists!
)

IF NOT EXIST Hearts.exe (
  ECHO %ME% : ...Going to copy Hearts from Windows System folder...
  IF EXIST %SYSTEMROOT%\system32\mshearts.exe (
    COPY %SYSTEMROOT%\system32\mshearts.exe  Hearts.exe >NUL
    IF ERRORLEVEL 1 (
      ECHO %ME% : Hearts copying failed.
    ) ELSE (
      ECHO %ME% : Hearts successfully copied.
    )
  ) ELSE (
    ECHO %ME% : Hearts not found.
  )
) ELSE (
  ECHO %ME% : Hearts already exists!
)

IF NOT EXIST Solitaire.exe (
  ECHO %ME% : ...Going to copy Solitaire from Windows System folder...
  IF EXIST %SYSTEMROOT%\system32\sol.exe (
    COPY %SYSTEMROOT%\system32\sol.exe  Solitaire.exe >NUL
    IF ERRORLEVEL 1 (
      ECHO %ME% : Solitaire copy failed. Exiting...
      GOTO END
    ) ELSE (
      ECHO %ME% : Solitaire successfully copied.
    )
  ) ELSE (
    ECHO %ME% : Solitaire not found. Exiting...
    GOTO END
  )
) ELSE (
  ECHO %ME% : Solitaire already exists!
)

ECHO.
SET /P ANS="Run Solitaire? [y/n]
IF ERRORLEVEL 1 SET ANS=y

IF %ANS:~0,1%==n GOTO END
IF %ANS:~0,1%==N GOTO END

ECHO %ME% : Going to run Solitaire...
START Solitaire.exe

:END
POPD
ENDLOCAL
ECHO.

